<template>
    <v-layout 
      class="white--text justify-center" 
      row ma-4>
      <v-flex xs12 md8 text-center>
        <h2 class="text-left text-uppercase">
          <v-autocomplete
            dark
            v-model="selected_symbol"
            :items="symbols"
            v-on:change="startWebSocket()"
            outlined
            label="Symbols"
            class="text-uppercase"
          ></v-autocomplete>
        </h2>
        <h3>Spread: {{bookTicker ? bookTicker.a - bookTicker.b : '-'}}</h3>
      </v-flex>
      <v-flex xs12 md10
       v-if="market_depth"
      >
        <v-simple-table
          dark
          dense
          class="transparent white--text"
        >
          <template>
            <thead>
              <tr>
                <th class="text-right caption" width="15%">Price</th>
                <th class="text-center" width="20%">Exchanged Volume</th>
                <th class="text-center" width="20%">Bid Volume</th>
                <th class="text-center caption" width="10%">Sell</th>
                <th class="text-center caption" width="10%">Buy</th>
                <th class="text-center caption" width="20%">Ask Volume</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(item, index) in ask" :key="index+'ask'">
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-right'">
                  <v-icon v-if="index == ask.length - 1 && price_up" large class="mr-1" color="success">mdi-menu-up</v-icon>
                   <v-icon v-if="index == ask.length - 1 && !price_up" large class="mr-1" color="error">mdi-menu-down</v-icon>
                  <b :class="index == ask.length - 1 ? price_up ? 'success--text' : 'pink--text':''">{{ item[0] ? parseFloat(item[0], 10) : 0 }}</b>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-right'">
                  <v-progress-linear 
                    color="grey"
                    height="20"
                    class="white--text text-trucate"
                    :value="history[item[0]] ? history[item[0]] / max_hist_volume * 100 : 0"
                  >
                    {{ history[item[0]] ? history[item[0]].toFixed(6) : '' }}
                  </v-progress-linear>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-center'">
                  <v-progress-linear 
                    background-color="blue"
                    color="blue darken-4"
                    height="20"
                    :value="100"
                  >
                  </v-progress-linear>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-center'">
                  <b class="pink--text"></b>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-center green darken-4' : 'text-center'">
                  <b class="blue--text text--lighten-3" v-if="index == ask.length - 1">{{ index == ask.length - 1 ? buys.toFixed(6) : '' }}</b>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-right'">
                  <v-progress-linear 
                    color="pink"
                    class="white--text"
                    height="20" 
                    :value="item[1] / max_volume * 100"
                  >
                      {{ Math.floor(parseFloat(item[1], 10)) }}
                    </v-progress-linear>
                </td>
              </tr>
              <tr v-for="(item, index) in market.bids" :key="index+'bid'">
                <td class="text-right">
                  <b 
                    :class="index == 0 ? 'primary--text text--lighten-2':''"
                  >
                    {{ item[0] ? parseFloat(item[0], 10) : 0 }}
                  </b>
                </td>
                <td>
                  <v-progress-linear 
                    color="grey"
                    height="20"
                    class="white--text"
                    :value="history[item[0]] ? history[item[0]] / max_hist_volume * 100 : 0"
                  >
                    {{ history[item[0]] && history[item[0]] != undefined ? history[item[0]].toFixed(6) : '' }}
                  </v-progress-linear>
                </td>
                <td>
                  <v-progress-linear 
                    height="20"
                    background-color="blue"
                    color="blue darken-4"
                    class="white--text"
                    :value="100 - ((item[1] / max_volume) * 100)"
                  >
                    {{ Math.floor(parseFloat(item[1], 10)) }}
                  </v-progress-linear>
                </td>
                <td class="text-center">
                  <b class="pink--text">{{ index == 0 ? sells.toFixed(6) : '' }}</b>
                </td>
                <td></td>
                <td>
                  <v-progress-linear 
                    color="pink"
                    height="20"
                    :value="0"
                  >
                  </v-progress-linear>
                </td>
              </tr>
            </tbody>
          </template>
        </v-simple-table>
      </v-flex>
    </v-layout>
</template>

<script>
import axios from 'axios'

  export default {
    name: 'OrderBook',
    data: () => ({
      socket: null,
      symbols: null,
      selected_symbol: 'btcusdt',
      depth: 'depth20',
      freq: '100ms',
      market_depth: null,
      data: null,
      data_bid: [],
      data_ask: null,
      max_ask: null,
      max_bid: null,
      max_volume: 0,
      timestamp: [],
      best_offer: null,
      price_up: false,
      history: {},
      history_heatmap: [],
      total_trades: 0,
      max_hist_volume: 0,
      current_buy_price: null,
      current_sell_price: null,
      buys: 0,
      sells: 0
    }),
    async mounted(){
      //Get symbol from local storage
      if(localStorage.getItem('symbol')){
        this.selected_symbol = localStorage.getItem('symbol')
      }

      this.startWebSocket()
      
      let list_symbols = await axios.get('http://localhost:8081/https://api.binance.com/api/v3/exchangeInfo')
      this.symbols = list_symbols.data.symbols.map(el => el.symbol.toLowerCase())

      //Init history from Binance API
      //this.getMarketHistory()

      //Periodic save history to local storage
      setInterval(this.saveHistory, 10000)
    },
    computed: {
      bookTicker(){
        return this.best_offer
      },
      market(){
        return this.market_depth ? this.market_depth : null
      },
      ask(){
        return this.market_depth ? this.market_depth.asks.slice(0).reverse() : null
      },
      series(){
        //let data = this.history_heatmap
        let price = this.history_heatmap.map(data => {
          return {
            name: data.p.toString(),
            data: [data.q]
          }
        })
        return price
      },
      chartOptions() {
        return { 
            chart: {
              height: 450,
              type: 'heatmap',
            },
            dataLabels: {
              enabled: false
            },
            xaxis: {
              type: 'timestamp',
              categories: this.timestamp
            },
            title: {
              text: 'HeatMap Chart (Different color shades for each series)'
            },
            grid: {
              padding: {
                right: 20
              }
            }
          }  
        }
    },
    methods:{
      async startWebSocket(){
        localStorage.setItem('symbol', this.selected_symbol)

        this.getMarketHistory()
        
        this.max_hist_volume = 0
        this.socket ? this.socket.close() : null
        this.socket = new WebSocket('wss://stream.binance.com:9443/stream?streams='+this.selected_symbol+'@'+this.depth+'@'+this.freq+'/'+this.selected_symbol+'@bookTicker/'+this.selected_symbol+'@trade');
        
        let vm = this

        //Listen websocket
        this.socket.addEventListener('message', function (data) {
            let json = JSON.parse(data.data)

            if(json.stream == vm.selected_symbol+'@'+vm.depth+'@'+vm.freq) {
              vm.market_depth = json.data              
            } 
            else if (json.stream == vm.selected_symbol+'@trade'){
              if(vm.current_sell_price == json.data.p) {
                vm.sells += parseFloat(json.data.q, 10)
              } else {
                vm.current_sell_price = json.data.p
                vm.sells = parseFloat(json.data.q, 10)
              }
              if (vm.current_buy_price == json.data.p) {
                vm.buys += parseFloat(json.data.q, 10)
              } {
                vm.current_buy_price = json.data.p
                vm.buys = parseFloat(json.data.q, 10)
              }
              
              vm.history[json.data.p] ? Object.assign(vm.history, {[json.data.p.toString()]: vm.history[json.data.p] + parseFloat(json.data.q, 10) }) : Object.assign(vm.history, { [json.data.p.toString()]: parseFloat(json.data.q, 10) })
                            
              json.data.q > vm.max_volume ? vm.max_volume = json.data.q : null
              vm.max_volume = Math.max(...[vm.max_ask, vm.max_bid])
              vm.max_hist_volume = Math.max.apply(null, Object.values(vm.history));
            }
            else {
              if(vm.best_offer){
                parseFloat(json.data.a, 10) > parseFloat(vm.best_offer.a, 10) ? vm.price_up = true : vm.price_up = false
              }
              vm.best_offer = json.data
            }
            
            vm.market_depth ? vm.max_ask = Math.max(...vm.market_depth.asks.map(el => el[1])) : null
            vm.market_depth ? vm.max_bid = Math.max(...vm.market_depth.bids.map(el => el[1])) : null
        });
      },
      getMarketHistory(){
        if(localStorage.getItem(`history_${this.selected_symbol}`)){
          return this.history = JSON.parse(localStorage.getItem(`history_${this.selected_symbol}`))
        } else {
          return this.history = {}
        }
      },
      saveHistory(){
        localStorage.setItem(`history_${this.selected_symbol}`, JSON.stringify(this.history))
      }
    }
  }
</script>
<style scoped>
.app{
  font-size: 1em;
}
</style>